function getLocalizedString(string)
{
	try { string = localizedStrings[string] || string; } catch (e) {}
	return string;
}

function createInstancePreferenceKey(key)
{
	return widget.identifier + "-" + key;
}

function getElementHeight(mainElement)
{
	var height = mainElement.offsetHeight;
	
	if (!height || height == 0) {
		height = getElementSize(mainElement).height;
	}
	
	return height;	
}

function getElementWidth(mainElement)
{
	var width = mainElement.offsetWidth;
	
	if (!width || width == 0) {
		width = getElementSize(mainElement).width;
	}
	
	return width;	
}

function getElementSize(mainElement)
{
	var width = mainElement.offsetWidth;
	var height = mainElement.offsetHeight;

	if (!width || width == 0 || !height || height == 0) {
		var displayNoneElements = new Array();

		var parentNode = mainElement;
		while (parentNode && (parentNode != document)) {
			var displayValue;
			var style = document.defaultView.getComputedStyle(parentNode, null);
			if (style) {
				displayValue = style.getPropertyValue("display");
			} else {
				// for Tiger
				displayValue = parentNode.style.display;
			}

			if (displayValue != "block") {
				displayNoneElements.push({node:parentNode, display:parentNode.style.display});
				parentNode.style.display = "block";
			}
			parentNode = parentNode.parentNode;
		}

		if (!width || width == 0) width = mainElement.offsetWidth;
		if (!height || height == 0) height = mainElement.offsetHeight;

		for (var i=0; i<displayNoneElements.length; i++) {
			var element = displayNoneElements[i].node;
			element.style.display = displayNoneElements[i].display;
			// clean up
			if (element.getAttribute("style") == "") {
				element.removeAttribute("style");
			}
		}
	}

	return {width:width, height:height};
}
